package org.jamon.node;

import org.jamon.api.Location;
public class AliasDefNode extends AbstractNode
{
  public AliasDefNode(Location p_location, String p_name, AbstractPathNode p_path)
  {
    super(p_location);
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
    if ((m_path = p_path) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAliasDefNode(this);
  }

  private final String m_name;
  public String getName() { return m_name; }

  private final AbstractPathNode m_path;
  public AbstractPathNode getPath() { return m_path; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_name.equals(((AliasDefNode) p_obj).m_name)
      && m_path.equals(((AliasDefNode) p_obj).m_path)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_name.hashCode()
      ^ m_path.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "name", m_name);
    addProperty(p_buffer, "path", m_path);
  }

}
