package org.jamon.node;

import org.jamon.api.Location;
public class AnnotationNode extends AbstractNode
{
  public AnnotationNode(Location p_location, String p_annotations, org.jamon.codegen.AnnotationType p_type)
  {
    super(p_location);
    if ((m_annotations = p_annotations) == null)
      { throw new NullPointerException(); }
    if ((m_type = p_type) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseAnnotationNode(this);
  }

  private final String m_annotations;
  public String getAnnotations() { return m_annotations; }

  private final org.jamon.codegen.AnnotationType m_type;
  public org.jamon.codegen.AnnotationType getType() { return m_type; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_annotations.equals(((AnnotationNode) p_obj).m_annotations)
      && m_type.equals(((AnnotationNode) p_obj).m_type)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_annotations.hashCode()
      ^ m_type.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "annotations", m_annotations);
    addProperty(p_buffer, "type", m_type);
  }

}
