package org.jamon.node;

import org.jamon.api.Location;
public class ArgValueNode extends AbstractNode
{
  public ArgValueNode(Location p_location, String p_value)
  {
    super(p_location);
    if ((m_value = p_value) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseArgValueNode(this);
  }

  private final String m_value;
  public String getValue() { return m_value; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_value.equals(((ArgValueNode) p_obj).m_value)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_value.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "value", m_value);
  }

}
