package org.jamon.node;

import org.jamon.api.Location;
public class ClassNode extends AbstractNode
{
  public ClassNode(Location p_location, String p_content)
  {
    super(p_location);
    if ((m_content = p_content) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseClassNode(this);
  }

  private final String m_content;
  public String getContent() { return m_content; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_content.equals(((ClassNode) p_obj).m_content)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_content.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "content", m_content);
  }

}
