package org.jamon.node;

import org.jamon.api.Location;
public class GenericCallParam extends AbstractNode
{
  public GenericCallParam(Location p_location, String p_className)
  {
    super(p_location);
    if ((m_className = p_className) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseGenericCallParam(this);
  }

  private final String m_className;
  public String getClassName() { return m_className; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_className.equals(((GenericCallParam) p_obj).m_className)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_className.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "className", m_className);
  }

}
