package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class GenericsNode extends AbstractNode
{
  public GenericsNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseGenericsNode(this);
  }

  private final List<GenericsParamNode> m_params = new ArrayList<GenericsParamNode>();
  public GenericsNode addParam(GenericsParamNode p_param)
  {
    if (p_param == null) { throw new NullPointerException(); }
    m_params.add(p_param);
    return this;
  }
  public List<GenericsParamNode> getParams() { return m_params; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_params.equals(((GenericsNode) p_obj).m_params)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_params.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "param", m_params);
  }

}
