package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class GenericsParamNode extends AbstractNode
{
  public GenericsParamNode(Location p_location, String p_name)
  {
    super(p_location);
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseGenericsParamNode(this);
  }

  private final String m_name;
  public String getName() { return m_name; }

  private final List<GenericsBoundNode> m_bounds = new ArrayList<GenericsBoundNode>();
  public GenericsParamNode addBound(GenericsBoundNode p_bound)
  {
    if (p_bound == null) { throw new NullPointerException(); }
    m_bounds.add(p_bound);
    return this;
  }
  public List<GenericsBoundNode> getBounds() { return m_bounds; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_name.equals(((GenericsParamNode) p_obj).m_name)
      && m_bounds.equals(((GenericsParamNode) p_obj).m_bounds)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_name.hashCode()
      ^ m_bounds.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "name", m_name);
    addPropertyList(p_buffer, "bound", m_bounds);
  }

}
