package org.jamon.node;

import java.util.ArrayList;
import java.util.List;

import org.jamon.api.Location;
public class ImportsNode extends AbstractNode
{
  public ImportsNode(Location p_location)
  {
    super(p_location);
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseImportsNode(this);
  }

  private final List<AbstractImportNode> m_imports = new ArrayList<AbstractImportNode>();
  public ImportsNode addImport(AbstractImportNode p_import)
  {
    if (p_import == null) { throw new NullPointerException(); }
    m_imports.add(p_import);
    return this;
  }
  public List<AbstractImportNode> getImports() { return m_imports; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_imports.equals(((ImportsNode) p_obj).m_imports)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_imports.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addPropertyList(p_buffer, "import", m_imports);
  }

}
