package org.jamon.node;

import org.jamon.api.Location;
public class JavaNode extends AbstractNode
{
  public JavaNode(Location p_location, String p_java)
  {
    super(p_location);
    if ((m_java = p_java) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseJavaNode(this);
  }

  private final String m_java;
  public String getJava() { return m_java; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_java.equals(((JavaNode) p_obj).m_java)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_java.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "java", m_java);
  }

}
