package org.jamon.node;

import org.jamon.api.Location;
public class NamedParamNode extends AbstractNode
{
  public NamedParamNode(Location p_location, ParamNameNode p_name, ParamValueNode p_value)
  {
    super(p_location);
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
    if ((m_value = p_value) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseNamedParamNode(this);
  }

  private final ParamNameNode m_name;
  public ParamNameNode getName() { return m_name; }

  private final ParamValueNode m_value;
  public ParamValueNode getValue() { return m_value; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_name.equals(((NamedParamNode) p_obj).m_name)
      && m_value.equals(((NamedParamNode) p_obj).m_value)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_name.hashCode()
      ^ m_value.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "name", m_name);
    addProperty(p_buffer, "value", m_value);
  }

}
